package com.example.myapplication

import android.graphics.PointF
import androidx.appcompat.app.AppCompatActivity
import android.os.Bundle
import android.util.Log
import com.example.myapplication.databinding.ActivityMainBinding
import com.oracle.aconex.pdftron.MobileViewer
import com.oracle.aconex.pdftron.pub.IAnnotationsDelegate
import com.oracle.aconex.pdftron.pub.IViewer
import com.pdftron.pdf.Annot
import com.pdftron.pdf.annots.FileAttachment
import com.pdftron.pdf.tools.ToolManager
import com.pdftron.pdf.utils.Utils

class MainActivity : AppCompatActivity(), ToolManager.AdvancedAnnotationListener,
    IAnnotationsDelegate {

    private lateinit var binding: ActivityMainBinding
    var mViewer: IViewer? = null
    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        binding = ActivityMainBinding.inflate(layoutInflater)
        mViewer = MobileViewer().createViewer(this)
        setContentView(binding.root)

        loadPDFinPdftron()
    }

    override fun fileAttachmentSelected(attachment: FileAttachment?) {

    }

    override fun freehandStylusUsedFirstTime() {

    }

    override fun imageStamperSelected(targetPoint: PointF?) {

    }

    override fun imageSignatureSelected(targetPoint: PointF?, targetPage: Int, widget: Long?) {

    }

    override fun attachFileSelected(targetPoint: PointF?) {

    }

    override fun freeTextInlineEditingStarted() {

    }

    override fun newFileSelectedFromTool(filePath: String?, pageNumber: Int): Boolean {
        return true
    }

    override fun fileCreated(
        fileLocation: String?,
        action: ToolManager.AdvancedAnnotationListener.AnnotAction?
    ) {

    }

    private fun loadPDFinPdftron() {
        this.let { activity ->
            val document = mViewer?.getDocument()
            val annotation = mViewer?.getAnnotation()
            annotation?.setAnnotationDelegate(activity)
            document?.addDocumentLoadListener {
                Log.d("Document", "on Document Loaded")
            }
            this.binding.annotationToolbar.removeAllViews()
            this.binding.container.addView(document?.view)
            document?.initialiseToolBar(activity, this)
            document?.showAnnotationToolBarForInspection(activity, this.binding.annotationToolbar)
            val file = Utils.copyResourceToLocal(activity, R.raw.sample_pdftron, "sample", ".pdf")
            document?.open(file.absolutePath)
            val xfdfFile = Utils.copyResourceToLocal(activity, R.raw.xfdf, "xfdf", ".txt")
            val stringFromFile = FileString.getStringFromFile(xfdfFile.absolutePath)
            stringFromFile?.let { mViewer?.setXfdf(it, true) }
        }
    }

    override fun annotationChanged(modifiedList: Set<Annot>?) {

    }

    override fun annotationCreated(addedList: Set<Annot>?) {

    }

    override fun annotationRemoved(deletedList: Set<Annot>?) {

    }

    override fun annotationSelected() {

    }
}